Index: /XIOS/trunk/src/transformation/domain_algorithm_reorder.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_reorder.hpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/domain_algorithm_reorder.hpp	(revision 1704)
@@ -26,4 +26,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Domain Trans. Filter \\n Reorder";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: /XIOS/trunk/src/transformation/domain_algorithm_transformation.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_transformation.hpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/domain_algorithm_transformation.hpp	(revision 1704)
@@ -27,4 +27,6 @@
   virtual ~CDomainAlgorithmTransformation();
 
+  virtual StdString getName() {return "Domain Trans. Filter \\n Transformation";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >&);
Index: /XIOS/trunk/src/transformation/domain_algorithm_zoom.hpp
===================================================================
--- /XIOS/trunk/src/transformation/domain_algorithm_zoom.hpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/domain_algorithm_zoom.hpp	(revision 1704)
@@ -23,4 +23,6 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Domain Trans. Filter \\n Zoom";}
 protected:
   void updateDomainAttributes();
Index: /XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp
===================================================================
--- /XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/generic_algorithm_transformation.hpp	(revision 1704)
@@ -73,4 +73,6 @@
                      std::vector<bool>& flagInitial,                     
                      bool ignoreMissingValue, bool firstPass);
+
+  virtual StdString getName() {return "Generic Trans. Filter";}
 
   /*!
Index: /XIOS/trunk/src/transformation/scalar_algorithm_extract_axis.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_extract_axis.hpp	(revision 1704)
@@ -39,4 +39,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Extract Axis";}
+
 protected:
   int pos_;
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_axis.cpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_axis.cpp	(revision 1704)
@@ -13,5 +13,4 @@
 #include "grid.hpp"
 #include "grid_transformation_factory_impl.hpp"
-#include "reduction.hpp"
 
 #include "reduction.hpp"
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_axis.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_axis.hpp	(revision 1704)
@@ -40,4 +40,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Reduce Axis";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_domain.hpp	(revision 1704)
@@ -40,4 +40,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Reduce Domain";}
+
 protected:
   bool local ;
Index: /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.hpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_reduce_scalar.hpp	(revision 1704)
@@ -35,4 +35,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Reduce Scalar";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: /XIOS/trunk/src/transformation/scalar_algorithm_transformation.hpp
===================================================================
--- /XIOS/trunk/src/transformation/scalar_algorithm_transformation.hpp	(revision 1703)
+++ /XIOS/trunk/src/transformation/scalar_algorithm_transformation.hpp	(revision 1704)
@@ -31,4 +31,6 @@
   virtual ~CScalarAlgorithmTransformation();
 
+  virtual StdString getName() {return "Scalar Trans. Filter \\n Transformation";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: /XIOS/trunk/src/workflow_graph.cpp
===================================================================
--- /XIOS/trunk/src/workflow_graph.cpp	(revision 1704)
+++ /XIOS/trunk/src/workflow_graph.cpp	(revision 1704)
@@ -0,0 +1,163 @@
+#include "workflow_graph.hpp"
+
+namespace xios
+{
+
+  std::unordered_map <int, graph_info_box_node> *CWorkflowGraph::mapFilters_ptr_with_info = 0;
+
+  std::unordered_map <int, graph_info_box_edge > *CWorkflowGraph::mapFieldToFilters_ptr_with_info = 0;
+
+  std::unordered_map <size_t, int> *CWorkflowGraph::mapHashFilterID_ptr = 0;
+
+
+  vector <StdString> CWorkflowGraph::filters;
+  vector <StdString> CWorkflowGraph::fields;
+  vector <pair<int, int> > CWorkflowGraph::fieldsToFilters;
+
+  bool CWorkflowGraph::build_begin = false;
+
+  CWorkflowGraph::CWorkflowGraph()
+  { }
+
+  /*!
+   * Reorganize information collected by XIOS for visualization.
+   */
+  void CWorkflowGraph::buildStaticWorkflow()
+  TRY
+  {
+    
+    if(mapFilters_ptr_with_info==0 || mapFieldToFilters_ptr_with_info==0) 
+      std::cout<<"No graph information provided"<<std::endl;
+
+    else // Create a list of filters (graph nodes)
+    {
+      size_t filterIdx = 0;
+      filters.resize(mapFilters_ptr_with_info->size());
+      fieldsToFilters.clear();
+      fields.clear();
+      for (auto it=mapFilters_ptr_with_info->begin(); it != mapFilters_ptr_with_info->end(); it++)
+      {
+        filters[it->first]=it->second.filter_name;
+      }
+
+      // Create a list of fields and their filter connectivity (graph edges and edge-to-node connectivity)
+      for (auto it=mapFieldToFilters_ptr_with_info->begin(); it != mapFieldToFilters_ptr_with_info->end(); it++)
+      {
+        fieldsToFilters.push_back(make_pair(it->second.from,it->second.to));
+        fields.push_back(it->second.field_id + " "+it->second.date.toString());
+      }
+    }
+  }
+  CATCH
+
+
+
+
+/*!
+   * Reorganize information collected by XIOS for visualization.
+   */
+  void CWorkflowGraph::buildStaticWorkflow_with_info()
+  TRY
+  {
+    // showStaticWorkflow();
+    
+    if(mapFilters_ptr_with_info==0 || mapFieldToFilters_ptr_with_info==0) 
+      std::cout<<"No graph information provided"<<std::endl;
+
+    else // Create a list of filters (graph nodes)
+    {
+      size_t filterIdx = 0;
+      filters.resize(mapFilters_ptr_with_info->size());
+      fieldsToFilters.clear();
+      fields.clear();
+      for (auto it=mapFilters_ptr_with_info->begin(); it != mapFilters_ptr_with_info->end(); it++)
+      {
+        // std::cout<<"it->first = "<<it->first<<std::endl;
+        filters[it->first]=it->second.filter_name;
+      }
+
+      // Create a list of fields and their filter connectivity (graph edges and edge-to-node connectivity)
+      for (auto it=mapFieldToFilters_ptr_with_info->begin(); it != mapFieldToFilters_ptr_with_info->end(); it++)
+      {
+        fieldsToFilters.push_back(make_pair(it->second.from,it->second.to));
+        fields.push_back(it->second.field_id + " "+it->second.date.toString());
+      }
+    }
+  }
+  CATCH
+
+
+
+  void CWorkflowGraph::showStaticWorkflow()
+  TRY
+  {
+    if(mapFilters_ptr_with_info!=0 && !mapFilters_ptr_with_info->empty())
+    for (auto it=mapFilters_ptr_with_info->begin(); it != mapFilters_ptr_with_info->end(); it++)
+    {
+      std::cout<<"mapFilters_ptr_with_info["<<it->first<<"].filter_name="<<it->second.filter_name<<std::endl;
+      std::cout<<"mapFilters_ptr_with_info["<<it->first<<"].filter_class="<<it->second.filter_class<<std::endl;
+      std::cout<<"mapFilters_ptr_with_info["<<it->first<<"].filter_fillled="<<it->second.filter_filled<<std::endl;
+      std::cout<<"mapFilters_ptr_with_info["<<it->first<<"].expected_entry_nb="<<it->second.expected_entry_nb<<std::endl;
+      std::cout<<"mapFilters_ptr_with_info["<<it->first<<"].date="<<it->second.date<<std::endl;
+      std::cout<<"mapFilters_ptr_with_info["<<it->first<<"].timestamp="<<it->second.timestamp<<std::endl;
+      std::cout<<"mapFilters_ptr_with_info["<<it->first<<"].transform_type="<<it->second.transform_type<<std::endl;
+    }
+    else std::cout<<"mapFilters_ptr_with_info empty"<<std::endl;
+
+    if(mapFieldToFilters_ptr_with_info!=0 && !mapFieldToFilters_ptr_with_info->empty())
+    for (auto it=mapFieldToFilters_ptr_with_info->begin(); it != mapFieldToFilters_ptr_with_info->end(); it++)
+    {
+      std::cout<<"mapFieldToFilters_ptr_with_info["<<it->first<<"].from = "<<it->second.from<<std::endl;
+      std::cout<<"mapFieldToFilters_ptr_with_info["<<it->first<<"].to = "<<it->second.to<<std::endl;
+      std::cout<<"mapFieldToFilters_ptr_with_info["<<it->first<<"].field_id = "<<it->second.field_id<<std::endl;
+      std::cout<<"mapFieldToFilters_ptr_with_info["<<it->first<<"].field_name = "<<it->second.field_name<<std::endl;
+      std::cout<<"mapFieldToFilters_ptr_with_info["<<it->first<<"].date = "<<it->second.date<<std::endl;
+      
+    }
+    else std::cout<<"mapFieldToFilters_ptr_with_info empty"<<std::endl;
+
+
+  }
+  CATCH
+
+
+  void CWorkflowGraph::addNode(int nodeID, StdString filterName, int filterClass, bool filterFilled, int entry_nb, CDataPacketPtr packet)
+  TRY
+  {
+    (*mapFilters_ptr_with_info)[nodeID].filter_name = filterName;
+    (*mapFilters_ptr_with_info)[nodeID].filter_class = filterClass;
+    (*mapFilters_ptr_with_info)[nodeID].filter_filled = filterFilled;
+    (*mapFilters_ptr_with_info)[nodeID].expected_entry_nb = entry_nb;
+    (*mapFilters_ptr_with_info)[nodeID].date = packet->date;
+    (*mapFilters_ptr_with_info)[nodeID].timestamp = packet->timestamp;
+  }
+  CATCH
+
+
+
+  void CWorkflowGraph::addEdge(int edgeID, int toID, CDataPacketPtr packet)
+  TRY
+  {
+    (*mapFieldToFilters_ptr_with_info)[edgeID].from = packet->src_filterID;
+    (*mapFieldToFilters_ptr_with_info)[edgeID].to = toID;
+    (*mapFieldToFilters_ptr_with_info)[edgeID].field_id = packet->field->getId();
+    (*mapFieldToFilters_ptr_with_info)[edgeID].field_name = packet->field->name;
+    (*mapFieldToFilters_ptr_with_info)[edgeID].grid_id = packet->field->grid->getId();
+    (*mapFieldToFilters_ptr_with_info)[edgeID].date = packet->date;
+    (*mapFieldToFilters_ptr_with_info)[edgeID].timestamp = packet->timestamp;
+    (*mapFieldToFilters_ptr_with_info)[edgeID].field = packet->field;
+    (*mapFieldToFilters_ptr_with_info)[edgeID].attributes = packet->field->record4graphXiosAttributes();
+  }
+  CATCH
+
+
+  void CWorkflowGraph::allocNodeEdge()
+  TRY
+  {
+    if(mapFilters_ptr_with_info==0) mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+    if(mapFieldToFilters_ptr_with_info==0) mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
+    if(mapHashFilterID_ptr==0) mapHashFilterID_ptr = new std::unordered_map <size_t, int >;
+  }
+  CATCH
+
+}
Index: /XIOS/trunk/src/workflow_graph.hpp
===================================================================
--- /XIOS/trunk/src/workflow_graph.hpp	(revision 1704)
+++ /XIOS/trunk/src/workflow_graph.hpp	(revision 1704)
@@ -0,0 +1,99 @@
+#ifndef __WORKFLOW_GRAPH_HPP__
+#define __WORKFLOW_GRAPH_HPP__
+
+#include "xios_spl.hpp"
+#include "field.hpp"
+#include "grid.hpp"
+#include "garbage_collector.hpp"
+#include "date.hpp"
+#include "duration.hpp"
+
+
+namespace xios
+{
+  class CField;
+
+  struct graph_info_box_node
+  {
+
+    StdString filter_name;
+    int filter_class;
+    bool filter_filled;
+    int expected_entry_nb;
+    CDate date;
+    Time timestamp;
+    StdString transform_type;
+    StdString attributes;
+    StdString field_id;
+    bool inputs_complete;
+    int filter_tag;
+    int clusterID;
+    int distance;
+  };
+
+  struct graph_info_box_edge
+  {
+    int from;
+    int to;
+    StdString field_id;
+    StdString field_name;
+    StdString grid_id;
+    CDate date;
+    Time timestamp;
+    CField *field;
+    StdString attributes;
+    
+  };
+
+  class CWorkflowGraph
+  {
+
+    friend class CGraphviz;
+
+    public:
+
+      CWorkflowGraph();
+
+      /*! Map between fields identified by its id and their filters identified by an integer.
+       * It is filled up during reconstruction of a workflow (in function CField::buildFilterGraph()).
+      */
+      // static std::unordered_map <StdString, vector <int> > *mapFieldToFilters_ptr;
+      // #pragma omp threadprivate(mapFieldToFilters_ptr)
+
+
+
+      static std::unordered_map <int, graph_info_box_node> *mapFilters_ptr_with_info;
+
+      static std::unordered_map <int, graph_info_box_edge> *mapFieldToFilters_ptr_with_info;
+
+      static std::unordered_map <size_t, int> *mapHashFilterID_ptr;
+
+
+      static bool build_begin;
+
+      static void addNode(int nodeID, StdString filterName, int filter_class, bool filter_filled, int entry_nb, CDataPacketPtr packet);
+      static void addEdge(int edgeID, int toID, CDataPacketPtr packet);
+      static void allocNodeEdge();
+
+    private:
+
+      //! List of fields marked for visualizing of their workflow
+      static vector <StdString> fields;
+
+      //! List of connected filters for fields for visualizing of their workflow
+      static vector <StdString> filters;
+
+      //! Fields to filters connectivity
+      static vector <pair<int, int> > fieldsToFilters;
+
+      static void buildStaticWorkflow();
+      static void buildStaticWorkflow_with_info();
+      static void showStaticWorkflow();
+
+      
+
+
+  };
+}
+
+#endif
